=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -45,6 +45,7 @@
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
 	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== modified file 'mandos'
--- mandos	2011-02-11 19:37:28 +0000
+++ mandos	2011-02-27 17:00:41 +0000
@@ -31,7 +31,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, absolute_import, unicode_literals
+from __future__ import division, with_statement, absolute_import
 
 import SocketServer as socketserver
 import socket
@@ -83,20 +83,20 @@
 
 version = "1.2.3"
 
-#logger = logging.getLogger('mandos')
-logger = logging.Logger('mandos')
+#logger = logging.getLogger(u'mandos')
+logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = "/dev/log"))
 syslogger.setFormatter(logging.Formatter
-                       ('Mandos [%(process)d]: %(levelname)s:'
-                        ' %(message)s'))
+                       (u'Mandos [%(process)d]: %(levelname)s:'
+                        u' %(message)s'))
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
-console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
-                                       ' %(levelname)s:'
-                                       ' %(message)s'))
+console.setFormatter(logging.Formatter(u'%(name)s [%(process)d]:'
+                                       u' %(levelname)s:'
+                                       u' %(message)s'))
 logger.addHandler(console)
 
 class AvahiError(Exception):
@@ -119,8 +119,8 @@
     Attributes:
     interface: integer; avahi.IF_UNSPEC or an interface index.
                Used to optionally bind to the specified interface.
-    name: string; Example: 'Mandos'
-    type: string; Example: '_mandos._tcp'.
+    name: string; Example: u'Mandos'
+    type: string; Example: u'_mandos._tcp'.
                   See <http://www.dns-sd.org/ServiceTypes.html>
     port: integer; what port to announce
     TXT: list of strings; TXT record for the service
@@ -135,7 +135,7 @@
     """
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
                  servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768,
+                 domain = u"", host = u"", max_renames = 32768,
                  protocol = avahi.PROTO_UNSPEC, bus = None):
         self.interface = interface
         self.name = name
@@ -153,22 +153,22 @@
     def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
-            logger.critical("No suitable Zeroconf service name found"
-                            " after %i retries, exiting.",
+            logger.critical(u"No suitable Zeroconf service name found"
+                            u" after %i retries, exiting.",
                             self.rename_count)
-            raise AvahiServiceError("Too many renames")
+            raise AvahiServiceError(u"Too many renames")
         self.name = unicode(self.server.GetAlternativeServiceName(self.name))
-        logger.info("Changing Zeroconf service name to %r ...",
+        logger.info(u"Changing Zeroconf service name to %r ...",
                     self.name)
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
+                               (u'Mandos (%s) [%%(process)d]:'
+                                u' %%(levelname)s: %%(message)s'
                                 % self.name))
         self.remove()
         try:
             self.add()
         except dbus.exceptions.DBusException, error:
-            logger.critical("DBusException: %s", error)
+            logger.critical(u"DBusException: %s", error)
             self.cleanup()
             os._exit(1)
         self.rename_count += 1
@@ -186,7 +186,7 @@
             self.group.connect_to_signal('StateChanged',
                                          self
                                          .entry_group_state_changed)
-        logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
+        logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
             self.interface,
@@ -199,17 +199,17 @@
         self.group.Commit()
     def entry_group_state_changed(self, state, error):
         """Derived from the Avahi example code"""
-        logger.debug("Avahi entry group state change: %i", state)
+        logger.debug(u"Avahi entry group state change: %i", state)
         
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
-            logger.debug("Zeroconf service established.")
+            logger.debug(u"Zeroconf service established.")
         elif state == avahi.ENTRY_GROUP_COLLISION:
-            logger.info("Zeroconf service name collision.")
+            logger.info(u"Zeroconf service name collision.")
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
-            logger.critical("Avahi: Error in group state changed %s",
+            logger.critical(u"Avahi: Error in group state changed %s",
                             unicode(error))
-            raise AvahiGroupError("State changed: %s"
+            raise AvahiGroupError(u"State changed: %s"
                                   % unicode(error))
     def cleanup(self):
         """Derived from the Avahi example code"""
@@ -218,9 +218,9 @@
             self.group = None
     def server_state_changed(self, state):
         """Derived from the Avahi example code"""
-        logger.debug("Avahi server state change: %i", state)
+        logger.debug(u"Avahi server state change: %i", state)
         if state == avahi.SERVER_COLLISION:
-            logger.error("Zeroconf server name collision")
+            logger.error(u"Zeroconf server name collision")
             self.remove()
         elif state == avahi.SERVER_RUNNING:
             self.add()
@@ -231,7 +231,7 @@
                 self.bus.get_object(avahi.DBUS_NAME,
                                     avahi.DBUS_PATH_SERVER),
                 avahi.DBUS_INTERFACE_SERVER)
-        self.server.connect_to_signal("StateChanged",
+        self.server.connect_to_signal(u"StateChanged",
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
@@ -272,10 +272,10 @@
     runtime_expansions: Allowed attributes for runtime expansion.
     """
     
-    runtime_expansions = ("approval_delay", "approval_duration",
-                          "created", "enabled", "fingerprint",
-                          "host", "interval", "last_checked_ok",
-                          "last_enabled", "name", "timeout")
+    runtime_expansions = (u"approval_delay", u"approval_duration",
+                          u"created", u"enabled", u"fingerprint",
+                          u"host", u"interval", u"last_checked_ok",
+                          u"last_enabled", u"name", u"timeout")
     
     @staticmethod
     def _timedelta_to_milliseconds(td):
@@ -302,47 +302,47 @@
         self.name = name
         if config is None:
             config = {}
-        logger.debug("Creating client %r", self.name)
+        logger.debug(u"Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
-        self.fingerprint = (config["fingerprint"].upper()
-                            .replace(" ", ""))
-        logger.debug("  Fingerprint: %s", self.fingerprint)
-        if "secret" in config:
-            self.secret = config["secret"].decode("base64")
-        elif "secfile" in config:
+        self.fingerprint = (config[u"fingerprint"].upper()
+                            .replace(u" ", u""))
+        logger.debug(u"  Fingerprint: %s", self.fingerprint)
+        if u"secret" in config:
+            self.secret = config[u"secret"].decode(u"base64")
+        elif u"secfile" in config:
             with open(os.path.expanduser(os.path.expandvars
-                                         (config["secfile"])),
+                                         (config[u"secfile"])),
                       "rb") as secfile:
                 self.secret = secfile.read()
         else:
-            raise TypeError("No secret or secfile for client %s"
+            raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
-        self.host = config.get("host", "")
+        self.host = config.get(u"host", u"")
         self.created = datetime.datetime.utcnow()
         self.enabled = False
         self.last_approval_request = None
         self.last_enabled = None
         self.last_checked_ok = None
-        self.timeout = string_to_delta(config["timeout"])
-        self.interval = string_to_delta(config["interval"])
+        self.timeout = string_to_delta(config[u"timeout"])
+        self.interval = string_to_delta(config[u"interval"])
         self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
         self.checker_callback_tag = None
-        self.checker_command = config["checker"]
+        self.checker_command = config[u"checker"]
         self.current_checker_command = None
         self.last_connect = None
         self._approved = None
-        self.approved_by_default = config.get("approved_by_default",
+        self.approved_by_default = config.get(u"approved_by_default",
                                               True)
         self.approvals_pending = 0
         self.approval_delay = string_to_delta(
-            config["approval_delay"])
+            config[u"approval_delay"])
         self.approval_duration = string_to_delta(
-            config["approval_duration"])
+            config[u"approval_duration"])
         self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
     
     def send_changedstate(self):
@@ -352,7 +352,7 @@
         
     def enable(self):
         """Start this client's checker and timeout hooks"""
-        if getattr(self, "enabled", False):
+        if getattr(self, u"enabled", False):
             # Already enabled
             return
         self.send_changedstate()
@@ -377,11 +377,11 @@
         if not quiet:
             self.send_changedstate()
         if not quiet:
-            logger.info("Disabling client %s", self.name)
-        if getattr(self, "disable_initiator_tag", False):
+            logger.info(u"Disabling client %s", self.name)
+        if getattr(self, u"disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
-        if getattr(self, "checker_initiator_tag", False):
+        if getattr(self, u"checker_initiator_tag", False):
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
@@ -402,14 +402,14 @@
         if os.WIFEXITED(condition):
             exitstatus = os.WEXITSTATUS(condition)
             if exitstatus == 0:
-                logger.info("Checker for %(name)s succeeded",
+                logger.info(u"Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
             else:
-                logger.info("Checker for %(name)s failed",
+                logger.info(u"Checker for %(name)s failed",
                             vars(self))
         else:
-            logger.warning("Checker for %(name)s crashed?",
+            logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
     
     def checked_ok(self):
@@ -450,7 +450,7 @@
                 raise error
         else:
             if pid:
-                logger.warning("Checker was a zombie")
+                logger.warning(u"Checker was a zombie")
                 gobject.source_remove(self.checker_callback_tag)
                 self.checker_callback(pid, status,
                                       self.current_checker_command)
@@ -463,21 +463,21 @@
                 # Escape attributes for the shell
                 escaped_attrs = dict(
                     (attr,
-                     re.escape(unicode(str(getattr(self, attr, "")),
+                     re.escape(unicode(str(getattr(self, attr, u"")),
                                        errors=
-                                       'replace')))
+                                       u'replace')))
                     for attr in
                     self.runtime_expansions)
 
                 try:
                     command = self.checker_command % escaped_attrs
                 except TypeError, error:
-                    logger.error('Could not format string "%s":'
-                                 ' %s', self.checker_command, error)
+                    logger.error(u'Could not format string "%s":'
+                                 u' %s', self.checker_command, error)
                     return True # Try again later
             self.current_checker_command = command
             try:
-                logger.info("Starting checker %r for %s",
+                logger.info(u"Starting checker %r for %s",
                             command, self.name)
                 # We don't need to redirect stdout and stderr, since
                 # in normal mode, that is already done by daemon(),
@@ -485,7 +485,7 @@
                 # always replaced by /dev/null.)
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
-                                                shell=True, cwd="/")
+                                                shell=True, cwd=u"/")
                 self.checker_callback_tag = (gobject.child_watch_add
                                              (self.checker.pid,
                                               self.checker_callback,
@@ -497,7 +497,7 @@
                     gobject.source_remove(self.checker_callback_tag)
                     self.checker_callback(pid, status, command)
             except OSError, error:
-                logger.error("Failed to start subprocess: %s",
+                logger.error(u"Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
@@ -507,9 +507,9 @@
         if self.checker_callback_tag:
             gobject.source_remove(self.checker_callback_tag)
             self.checker_callback_tag = None
-        if getattr(self, "checker", None) is None:
+        if getattr(self, u"checker", None) is None:
             return
-        logger.debug("Stopping checker for %(name)s", vars(self))
+        logger.debug(u"Stopping checker for %(name)s", vars(self))
         try:
             os.kill(self.checker.pid, signal.SIGTERM)
             #time.sleep(0.5)
@@ -520,8 +520,8 @@
                 raise
         self.checker = None
 
-def dbus_service_property(dbus_interface, signature="v",
-                          access="readwrite", byte_arrays=False):
+def dbus_service_property(dbus_interface, signature=u"v",
+                          access=u"readwrite", byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
     become properties on the D-Bus.
     
@@ -534,18 +534,18 @@
     """
     # Encoding deeply encoded byte arrays is not supported yet by the
     # "Set" method, so we fail early here:
-    if byte_arrays and signature != "ay":
-        raise ValueError("Byte arrays not supported for non-'ay'"
-                         " signature %r" % signature)
+    if byte_arrays and signature != u"ay":
+        raise ValueError(u"Byte arrays not supported for non-'ay'"
+                         u" signature %r" % signature)
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
         func._dbus_signature = signature
         func._dbus_access = access
         func._dbus_name = func.__name__
-        if func._dbus_name.endswith("_dbus_property"):
+        if func._dbus_name.endswith(u"_dbus_property"):
             func._dbus_name = func._dbus_name[:-14]
-        func._dbus_get_args_options = {'byte_arrays': byte_arrays }
+        func._dbus_get_args_options = {u'byte_arrays': byte_arrays }
         return func
     return decorator
 
@@ -579,7 +579,7 @@
     
     @staticmethod
     def _is_dbus_property(obj):
-        return getattr(obj, "_dbus_is_property", False)
+        return getattr(obj, u"_dbus_is_property", False)
     
     def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
@@ -593,7 +593,7 @@
         property with the specified name and interface.
         """
         for name in (property_name,
-                     property_name + "_dbus_property"):
+                     property_name + u"_dbus_property"):
             prop = getattr(self, name, None)
             if (prop is None
                 or not self._is_dbus_property(prop)
@@ -603,41 +603,41 @@
                 continue
             return prop
         # No such property
-        raise DBusPropertyNotFound(self.dbus_object_path + ":"
-                                   + interface_name + "."
+        raise DBusPropertyNotFound(self.dbus_object_path + u":"
+                                   + interface_name + u"."
                                    + property_name)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ss",
-                         out_signature="v")
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ss",
+                         out_signature=u"v")
     def Get(self, interface_name, property_name):
         """Standard D-Bus property Get() method, see D-Bus standard.
         """
         prop = self._get_dbus_property(interface_name, property_name)
-        if prop._dbus_access == "write":
+        if prop._dbus_access == u"write":
             raise DBusPropertyAccessException(property_name)
         value = prop()
-        if not hasattr(value, "variant_level"):
+        if not hasattr(value, u"variant_level"):
             return value
         return type(value)(value, variant_level=value.variant_level+1)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ssv")
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ssv")
     def Set(self, interface_name, property_name, value):
         """Standard D-Bus property Set() method, see D-Bus standard.
         """
         prop = self._get_dbus_property(interface_name, property_name)
-        if prop._dbus_access == "read":
+        if prop._dbus_access == u"read":
             raise DBusPropertyAccessException(property_name)
-        if prop._dbus_get_args_options["byte_arrays"]:
+        if prop._dbus_get_args_options[u"byte_arrays"]:
             # The byte_arrays option is not supported yet on
             # signatures other than "ay".
-            if prop._dbus_signature != "ay":
+            if prop._dbus_signature != u"ay":
                 raise ValueError
             value = dbus.ByteArray(''.join(unichr(byte)
                                            for byte in value))
         prop(value)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="s",
-                         out_signature="a{sv}")
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"s",
+                         out_signature=u"a{sv}")
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
         standard.
@@ -651,18 +651,18 @@
                 # Interface non-empty but did not match
                 continue
             # Ignore write-only properties
-            if prop._dbus_access == "write":
+            if prop._dbus_access == u"write":
                 continue
             value = prop()
-            if not hasattr(value, "variant_level"):
+            if not hasattr(value, u"variant_level"):
                 all[name] = value
                 continue
             all[name] = type(value)(value, variant_level=
                                     value.variant_level+1)
-        return dbus.Dictionary(all, signature="sv")
+        return dbus.Dictionary(all, signature=u"sv")
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
-                         out_signature="s",
+                         out_signature=u"s",
                          path_keyword='object_path',
                          connection_keyword='connection')
     def Introspect(self, object_path, connection):
@@ -673,38 +673,38 @@
         try:
             document = xml.dom.minidom.parseString(xmlstring)
             def make_tag(document, name, prop):
-                e = document.createElement("property")
-                e.setAttribute("name", name)
-                e.setAttribute("type", prop._dbus_signature)
-                e.setAttribute("access", prop._dbus_access)
+                e = document.createElement(u"property")
+                e.setAttribute(u"name", name)
+                e.setAttribute(u"type", prop._dbus_signature)
+                e.setAttribute(u"access", prop._dbus_access)
                 return e
-            for if_tag in document.getElementsByTagName("interface"):
+            for if_tag in document.getElementsByTagName(u"interface"):
                 for tag in (make_tag(document, name, prop)
                             for name, prop
                             in self._get_all_dbus_properties()
                             if prop._dbus_interface
-                            == if_tag.getAttribute("name")):
+                            == if_tag.getAttribute(u"name")):
                     if_tag.appendChild(tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
-                if (if_tag.getAttribute("name")
-                    == "org.freedesktop.DBus.Properties"):
-                    for cn in if_tag.getElementsByTagName("method"):
-                        if cn.getAttribute("name") == "Get":
-                            for arg in cn.getElementsByTagName("arg"):
-                                if (arg.getAttribute("direction")
-                                    == "out"):
-                                    arg.setAttribute("name", "value")
-                        elif cn.getAttribute("name") == "GetAll":
-                            for arg in cn.getElementsByTagName("arg"):
-                                if (arg.getAttribute("direction")
-                                    == "out"):
-                                    arg.setAttribute("name", "props")
-            xmlstring = document.toxml("utf-8")
+                if (if_tag.getAttribute(u"name")
+                    == u"org.freedesktop.DBus.Properties"):
+                    for cn in if_tag.getElementsByTagName(u"method"):
+                        if cn.getAttribute(u"name") == u"Get":
+                            for arg in cn.getElementsByTagName(u"arg"):
+                                if (arg.getAttribute(u"direction")
+                                    == u"out"):
+                                    arg.setAttribute(u"name", u"value")
+                        elif cn.getAttribute(u"name") == u"GetAll":
+                            for arg in cn.getElementsByTagName(u"arg"):
+                                if (arg.getAttribute(u"direction")
+                                    == u"out"):
+                                    arg.setAttribute(u"name", u"props")
+            xmlstring = document.toxml(u"utf-8")
             document.unlink()
         except (AttributeError, xml.dom.DOMException,
                 xml.parsers.expat.ExpatError), error:
-            logger.error("Failed to override Introspection method",
+            logger.error(u"Failed to override Introspection method",
                          error)
         return xmlstring
 
@@ -718,7 +718,7 @@
     """
     
     runtime_expansions = (Client.runtime_expansions
-                          + ("dbus_object_path",))
+                          + (u"dbus_object_path",))
     
     # dbus.service.Object doesn't use super(), so we can't either.
     
@@ -729,10 +729,10 @@
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
-            {ord("."): ord("_"),
-             ord("-"): ord("_")})
+            {ord(u"."): ord(u"_"),
+             ord(u"-"): ord(u"_")})
         self.dbus_object_path = (dbus.ObjectPath
-                                 ("/clients/" + client_object_name))
+                                 (u"/clients/" + client_object_name))
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
         
@@ -745,7 +745,7 @@
         if (hasattr(self, "dbus_object_path")
             and bval is not bool(old_value)):
             dbus_bool = dbus.Boolean(bval, variant_level=1)
-            self.PropertyChanged(dbus.String("ApprovalPending"),
+            self.PropertyChanged(dbus.String(u"ApprovalPending"),
                                  dbus_bool)
 
     approvals_pending = property(_get_approvals_pending,
@@ -759,24 +759,24 @@
                            variant_level=variant_level)
     
     def enable(self):
-        oldstate = getattr(self, "enabled", False)
+        oldstate = getattr(self, u"enabled", False)
         r = Client.enable(self)
         if oldstate != self.enabled:
             # Emit D-Bus signals
-            self.PropertyChanged(dbus.String("Enabled"),
+            self.PropertyChanged(dbus.String(u"Enabled"),
                                  dbus.Boolean(True, variant_level=1))
             self.PropertyChanged(
-                dbus.String("LastEnabled"),
+                dbus.String(u"LastEnabled"),
                 self._datetime_to_dbus(self.last_enabled,
                                        variant_level=1))
         return r
     
     def disable(self, quiet = False):
-        oldstate = getattr(self, "enabled", False)
+        oldstate = getattr(self, u"enabled", False)
         r = Client.disable(self, quiet=quiet)
         if not quiet and oldstate != self.enabled:
             # Emit D-Bus signal
-            self.PropertyChanged(dbus.String("Enabled"),
+            self.PropertyChanged(dbus.String(u"Enabled"),
                                  dbus.Boolean(False, variant_level=1))
         return r
     
@@ -785,7 +785,7 @@
             self.remove_from_connection()
         except LookupError:
             pass
-        if hasattr(DBusObjectWithProperties, "__del__"):
+        if hasattr(DBusObjectWithProperties, u"__del__"):
             DBusObjectWithProperties.__del__(self, *args, **kwargs)
         Client.__del__(self, *args, **kwargs)
     
@@ -794,7 +794,7 @@
         self.checker_callback_tag = None
         self.checker = None
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("CheckerRunning"),
+        self.PropertyChanged(dbus.String(u"CheckerRunning"),
                              dbus.Boolean(False, variant_level=1))
         if os.WIFEXITED(condition):
             exitstatus = os.WEXITSTATUS(condition)
@@ -815,7 +815,7 @@
         r = Client.checked_ok(self, *args, **kwargs)
         # Emit D-Bus signal
         self.PropertyChanged(
-            dbus.String("LastCheckedOK"),
+            dbus.String(u"LastCheckedOK"),
             (self._datetime_to_dbus(self.last_checked_ok,
                                     variant_level=1)))
         return r
@@ -824,7 +824,7 @@
         r = Client.need_approval(self, *args, **kwargs)
         # Emit D-Bus signal
         self.PropertyChanged(
-            dbus.String("LastApprovalRequest"),
+            dbus.String(u"LastApprovalRequest"),
             (self._datetime_to_dbus(self.last_approval_request,
                                     variant_level=1)))
         return r
@@ -842,16 +842,16 @@
             # Emit D-Bus signal
             self.CheckerStarted(self.current_checker_command)
             self.PropertyChanged(
-                dbus.String("CheckerRunning"),
+                dbus.String(u"CheckerRunning"),
                 dbus.Boolean(True, variant_level=1))
         return r
     
     def stop_checker(self, *args, **kwargs):
-        old_checker = getattr(self, "checker", None)
+        old_checker = getattr(self, u"checker", None)
         r = Client.stop_checker(self, *args, **kwargs)
         if (old_checker is not None
-            and getattr(self, "checker", None) is None):
-            self.PropertyChanged(dbus.String("CheckerRunning"),
+            and getattr(self, u"checker", None) is None):
+            self.PropertyChanged(dbus.String(u"CheckerRunning"),
                                  dbus.Boolean(False, variant_level=1))
         return r
 
@@ -868,24 +868,24 @@
     
     
     ## D-Bus methods, signals & properties
-    _interface = "se.bsnet.fukt.Mandos.Client"
+    _interface = u"se.bsnet.fukt.Mandos.Client"
     
     ## Signals
     
     # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature="nxs")
+    @dbus.service.signal(_interface, signature=u"nxs")
     def CheckerCompleted(self, exitcode, waitstatus, command):
         "D-Bus signal"
         pass
     
     # CheckerStarted - signal
-    @dbus.service.signal(_interface, signature="s")
+    @dbus.service.signal(_interface, signature=u"s")
     def CheckerStarted(self, command):
         "D-Bus signal"
         pass
     
     # PropertyChanged - signal
-    @dbus.service.signal(_interface, signature="sv")
+    @dbus.service.signal(_interface, signature=u"sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
         pass
@@ -900,13 +900,13 @@
         pass
     
     # Rejected - signal
-    @dbus.service.signal(_interface, signature="s")
+    @dbus.service.signal(_interface, signature=u"s")
     def Rejected(self, reason):
         "D-Bus signal"
         pass
     
     # NeedApproval - signal
-    @dbus.service.signal(_interface, signature="tb")
+    @dbus.service.signal(_interface, signature=u"tb")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
         return self.need_approval()
@@ -914,7 +914,7 @@
     ## Methods
     
     # Approve - method
-    @dbus.service.method(_interface, in_signature="b")
+    @dbus.service.method(_interface, in_signature=u"b")
     def Approve(self, value):
         self.approve(value)
     
@@ -949,80 +949,80 @@
     ## Properties
     
     # ApprovalPending - property
-    @dbus_service_property(_interface, signature="b", access="read")
+    @dbus_service_property(_interface, signature=u"b", access=u"read")
     def ApprovalPending_dbus_property(self):
         return dbus.Boolean(bool(self.approvals_pending))
     
     # ApprovedByDefault - property
-    @dbus_service_property(_interface, signature="b",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
     def ApprovedByDefault_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.approved_by_default)
         self.approved_by_default = bool(value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("ApprovedByDefault"),
+        self.PropertyChanged(dbus.String(u"ApprovedByDefault"),
                              dbus.Boolean(value, variant_level=1))
     
     # ApprovalDelay - property
-    @dbus_service_property(_interface, signature="t",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("ApprovalDelay"),
+        self.PropertyChanged(dbus.String(u"ApprovalDelay"),
                              dbus.UInt64(value, variant_level=1))
     
     # ApprovalDuration - property
-    @dbus_service_property(_interface, signature="t",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self._timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("ApprovalDuration"),
+        self.PropertyChanged(dbus.String(u"ApprovalDuration"),
                              dbus.UInt64(value, variant_level=1))
     
     # Name - property
-    @dbus_service_property(_interface, signature="s", access="read")
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
     def Name_dbus_property(self):
         return dbus.String(self.name)
     
     # Fingerprint - property
-    @dbus_service_property(_interface, signature="s", access="read")
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
     def Fingerprint_dbus_property(self):
         return dbus.String(self.fingerprint)
     
     # Host - property
-    @dbus_service_property(_interface, signature="s",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
         self.host = value
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Host"),
+        self.PropertyChanged(dbus.String(u"Host"),
                              dbus.String(value, variant_level=1))
     
     # Created - property
-    @dbus_service_property(_interface, signature="s", access="read")
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
     def Created_dbus_property(self):
         return dbus.String(self._datetime_to_dbus(self.created))
     
     # LastEnabled - property
-    @dbus_service_property(_interface, signature="s", access="read")
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
     def LastEnabled_dbus_property(self):
         if self.last_enabled is None:
-            return dbus.String("")
+            return dbus.String(u"")
         return dbus.String(self._datetime_to_dbus(self.last_enabled))
     
     # Enabled - property
-    @dbus_service_property(_interface, signature="b",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
     def Enabled_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.enabled)
@@ -1032,37 +1032,37 @@
             self.disable()
     
     # LastCheckedOK - property
-    @dbus_service_property(_interface, signature="s",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
     def LastCheckedOK_dbus_property(self, value=None):
         if value is not None:
             self.checked_ok()
             return
         if self.last_checked_ok is None:
-            return dbus.String("")
+            return dbus.String(u"")
         return dbus.String(self._datetime_to_dbus(self
                                                   .last_checked_ok))
     
     # LastApprovalRequest - property
-    @dbus_service_property(_interface, signature="s", access="read")
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
     def LastApprovalRequest_dbus_property(self):
         if self.last_approval_request is None:
-            return dbus.String("")
+            return dbus.String(u"")
         return dbus.String(self.
                            _datetime_to_dbus(self
                                              .last_approval_request))
     
     # Timeout - property
-    @dbus_service_property(_interface, signature="t",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.timeout_milliseconds())
         self.timeout = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Timeout"),
+        self.PropertyChanged(dbus.String(u"Timeout"),
                              dbus.UInt64(value, variant_level=1))
-        if getattr(self, "disable_initiator_tag", None) is None:
+        if getattr(self, u"disable_initiator_tag", None) is None:
             return
         # Reschedule timeout
         gobject.source_remove(self.disable_initiator_tag)
@@ -1081,16 +1081,16 @@
                                           (time_to_die, self.disable))
     
     # Interval - property
-    @dbus_service_property(_interface, signature="t",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Interval"),
+        self.PropertyChanged(dbus.String(u"Interval"),
                              dbus.UInt64(value, variant_level=1))
-        if getattr(self, "checker_initiator_tag", None) is None:
+        if getattr(self, u"checker_initiator_tag", None) is None:
             return
         # Reschedule checker run
         gobject.source_remove(self.checker_initiator_tag)
@@ -1099,20 +1099,20 @@
         self.start_checker()    # Start one now, too
 
     # Checker - property
-    @dbus_service_property(_interface, signature="s",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
         self.checker_command = value
         # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Checker"),
+        self.PropertyChanged(dbus.String(u"Checker"),
                              dbus.String(self.checker_command,
                                          variant_level=1))
     
     # CheckerRunning - property
-    @dbus_service_property(_interface, signature="b",
-                           access="readwrite")
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
     def CheckerRunning_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.checker is not None)
@@ -1122,13 +1122,13 @@
             self.stop_checker()
     
     # ObjectPath - property
-    @dbus_service_property(_interface, signature="o", access="read")
+    @dbus_service_property(_interface, signature=u"o", access=u"read")
     def ObjectPath_dbus_property(self):
         return self.dbus_object_path # is already a dbus.ObjectPath
     
     # Secret = property
-    @dbus_service_property(_interface, signature="ay",
-                           access="write", byte_arrays=True)
+    @dbus_service_property(_interface, signature=u"ay",
+                           access=u"write", byte_arrays=True)
     def Secret_dbus_property(self, value):
         self.secret = str(value)
     
@@ -1169,9 +1169,9 @@
     
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
-            logger.info("TCP connection from: %s",
+            logger.info(u"TCP connection from: %s",
                         unicode(self.client_address))
-            logger.debug("Pipe FD: %d",
+            logger.debug(u"Pipe FD: %d",
                          self.server.child_pipe.fileno())
 
             session = (gnutls.connection
@@ -1184,14 +1184,14 @@
             # no X.509 keys are added to it.  Therefore, we can use it
             # here despite using OpenPGP certificates.
 
-            #priority = ':'.join(("NONE", "+VERS-TLS1.1",
-            #                      "+AES-256-CBC", "+SHA1",
-            #                      "+COMP-NULL", "+CTYPE-OPENPGP",
-            #                      "+DHE-DSS"))
+            #priority = u':'.join((u"NONE", u"+VERS-TLS1.1",
+            #                      u"+AES-256-CBC", u"+SHA1",
+            #                      u"+COMP-NULL", u"+CTYPE-OPENPGP",
+            #                      u"+DHE-DSS"))
             # Use a fallback default, since this MUST be set.
             priority = self.server.gnutls_priority
             if priority is None:
-                priority = "NORMAL"
+                priority = u"NORMAL"
             (gnutls.library.functions
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
@@ -1199,23 +1199,23 @@
             # Start communication using the Mandos protocol
             # Get protocol number
             line = self.request.makefile().readline()
-            logger.debug("Protocol version: %r", line)
+            logger.debug(u"Protocol version: %r", line)
             try:
                 if int(line.strip().split()[0]) > 1:
                     raise RuntimeError
             except (ValueError, IndexError, RuntimeError), error:
-                logger.error("Unknown protocol version: %s", error)
+                logger.error(u"Unknown protocol version: %s", error)
                 return
 
             # Start GnuTLS connection
             try:
                 session.handshake()
             except gnutls.errors.GNUTLSError, error:
-                logger.warning("Handshake failed: %s", error)
+                logger.warning(u"Handshake failed: %s", error)
                 # Do not run session.bye() here: the session is not
                 # established.  Just abandon the request.
                 return
-            logger.debug("Handshake succeeded")
+            logger.debug(u"Handshake succeeded")
 
             approval_required = False
             try:
@@ -1223,9 +1223,9 @@
                     fpr = self.fingerprint(self.peer_certificate
                                            (session))
                 except (TypeError, gnutls.errors.GNUTLSError), error:
-                    logger.warning("Bad certificate: %s", error)
+                    logger.warning(u"Bad certificate: %s", error)
                     return
-                logger.debug("Fingerprint: %s", fpr)
+                logger.debug(u"Fingerprint: %s", fpr)
 
                 try:
                     client = ProxyClient(child_pipe, fpr,
@@ -1240,7 +1240,7 @@
                 
                 while True:
                     if not client.enabled:
-                        logger.warning("Client %s is disabled",
+                        logger.warning(u"Client %s is disabled",
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
@@ -1251,7 +1251,7 @@
                         #We are approved or approval is disabled
                         break
                     elif client._approved is None:
-                        logger.info("Client %s needs approval",
+                        logger.info(u"Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
@@ -1259,7 +1259,7 @@
                                 client.approval_delay_milliseconds(),
                                 client.approved_by_default)
                     else:
-                        logger.warning("Client %s was not approved",
+                        logger.warning(u"Client %s was not approved",
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
@@ -1294,12 +1294,12 @@
                     except (gnutls.errors.GNUTLSError), error:
                         logger.warning("gnutls send failed")
                         return
-                    logger.debug("Sent: %d, remaining: %d",
+                    logger.debug(u"Sent: %d, remaining: %d",
                                  sent, len(client.secret)
                                  - (sent_size + sent))
                     sent_size += sent
 
-                logger.info("Sending secret to %s", client.name)
+                logger.info(u"Sending secret to %s", client.name)
                 # bump the timeout as if seen
                 client.checked_ok()
                 if self.server.use_dbus:
@@ -1328,8 +1328,8 @@
                      .gnutls_certificate_get_peers
                      (session._c_object, ctypes.byref(list_size)))
         if not bool(cert_list) and list_size.value != 0:
-            raise gnutls.errors.GNUTLSError("error getting peer"
-                                            " certificate")
+            raise gnutls.errors.GNUTLSError(u"error getting peer"
+                                            u" certificate")
         if list_size.value == 0:
             return None
         cert = cert_list[0]
@@ -1361,7 +1361,7 @@
         if crtverify.value != 0:
             gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
             raise (gnutls.errors.CertificateSecurityError
-                   ("Verify failed"))
+                   (u"Verify failed"))
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
@@ -1374,7 +1374,7 @@
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = ''.join("%02X" % ord(char) for char in fpr)
+        hex_fpr = u''.join(u"%02X" % ord(char) for char in fpr)
         return hex_fpr
 
 
@@ -1408,7 +1408,7 @@
 
     def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
-        pass
+        raise NotImplementedError
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
@@ -1432,23 +1432,23 @@
         bind to an address or port if they were not specified."""
         if self.interface is not None:
             if SO_BINDTODEVICE is None:
-                logger.error("SO_BINDTODEVICE does not exist;"
-                             " cannot bind to interface %s",
+                logger.error(u"SO_BINDTODEVICE does not exist;"
+                             u" cannot bind to interface %s",
                              self.interface)
             else:
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
                                            str(self.interface
-                                               + '\0'))
+                                               + u'\0'))
                 except socket.error, error:
                     if error[0] == errno.EPERM:
-                        logger.error("No permission to"
-                                     " bind to interface %s",
+                        logger.error(u"No permission to"
+                                     u" bind to interface %s",
                                      self.interface)
                     elif error[0] == errno.ENOPROTOOPT:
-                        logger.error("SO_BINDTODEVICE not available;"
-                                     " cannot bind to interface %s",
+                        logger.error(u"SO_BINDTODEVICE not available;"
+                                     u" cannot bind to interface %s",
                                      self.interface)
                     else:
                         raise
@@ -1456,7 +1456,7 @@
         if self.server_address[0] or self.server_address[1]:
             if not self.server_address[0]:
                 if self.address_family == socket.AF_INET6:
-                    any_address = "::" # in6addr_any
+                    any_address = u"::" # in6addr_any
                 else:
                     any_address = socket.INADDR_ANY
                 self.server_address = (any_address,
@@ -1511,12 +1511,12 @@
     def handle_ipc(self, source, condition, parent_pipe=None,
                    client_object=None):
         condition_names = {
-            gobject.IO_IN: "IN",   # There is data to read.
-            gobject.IO_OUT: "OUT", # Data can be written (without
+            gobject.IO_IN: u"IN",   # There is data to read.
+            gobject.IO_OUT: u"OUT", # Data can be written (without
                                     # blocking).
-            gobject.IO_PRI: "PRI", # There is urgent data to read.
-            gobject.IO_ERR: "ERR", # Error condition.
-            gobject.IO_HUP: "HUP"  # Hung up (the connection has been
+            gobject.IO_PRI: u"PRI", # There is urgent data to read.
+            gobject.IO_ERR: u"ERR", # Error condition.
+            gobject.IO_HUP: u"HUP"  # Hung up (the connection has been
                                     # broken, usually for pipes and
                                     # sockets).
             }
@@ -1541,8 +1541,8 @@
                     client = c
                     break
             else:
-                logger.warning("Client not found for fingerprint: %s, ad"
-                               "dress: %s", fpr, address)
+                logger.warning(u"Client not found for fingerprint: %s, ad"
+                               u"dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
                     mandos_dbus_service.ClientNotFound(fpr, address[0])
@@ -1582,17 +1582,17 @@
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
-    >>> string_to_delta('7d')
+    >>> string_to_delta(u'7d')
     datetime.timedelta(7)
-    >>> string_to_delta('60s')
+    >>> string_to_delta(u'60s')
     datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
+    >>> string_to_delta(u'60m')
     datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
+    >>> string_to_delta(u'24h')
     datetime.timedelta(1)
-    >>> string_to_delta('1w')
+    >>> string_to_delta(u'1w')
     datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
+    >>> string_to_delta(u'5m 30s')
     datetime.timedelta(0, 330)
     """
     timevalue = datetime.timedelta(0)
@@ -1600,20 +1600,20 @@
         try:
             suffix = unicode(s[-1])
             value = int(s[:-1])
-            if suffix == "d":
+            if suffix == u"d":
                 delta = datetime.timedelta(value)
-            elif suffix == "s":
+            elif suffix == u"s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == "m":
+            elif suffix == u"m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == "h":
+            elif suffix == u"h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == "w":
+            elif suffix == u"w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix %r" % suffix)
+                raise ValueError(u"Unknown suffix %r" % suffix)
         except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+            raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
 
@@ -1625,18 +1625,18 @@
     global if_nametoindex
     try:
         if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library("c"))
+                          (ctypes.util.find_library(u"c"))
                           .if_nametoindex)
     except (OSError, AttributeError):
-        logger.warning("Doing if_nametoindex the hard way")
+        logger.warning(u"Doing if_nametoindex the hard way")
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
             with contextlib.closing(socket.socket()) as s:
                 ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack(str("16s16x"),
+                                    struct.pack(str(u"16s16x"),
                                                 interface))
-            interface_index = struct.unpack(str("I"),
+            interface_index = struct.unpack(str(u"I"),
                                             ifreq[16:20])[0]
             return interface_index
     return if_nametoindex(interface)
@@ -1650,7 +1650,7 @@
         sys.exit()
     os.setsid()
     if not nochdir:
-        os.chdir("/")
+        os.chdir(u"/")
     if os.fork():
         sys.exit()
     if not noclose:
@@ -1658,7 +1658,7 @@
         null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          "%s not a character device"
+                          u"%s not a character device"
                           % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -1673,32 +1673,32 @@
     # Parsing of options, both command line and config file
     
     parser = optparse.OptionParser(version = "%%prog %s" % version)
-    parser.add_option("-i", "--interface", type="string",
-                      metavar="IF", help="Bind to interface IF")
-    parser.add_option("-a", "--address", type="string",
-                      help="Address to listen for requests on")
-    parser.add_option("-p", "--port", type="int",
-                      help="Port number to receive requests on")
-    parser.add_option("--check", action="store_true",
-                      help="Run self-test")
-    parser.add_option("--debug", action="store_true",
-                      help="Debug mode; run in foreground and log to"
-                      " terminal")
-    parser.add_option("--debuglevel", type="string", metavar="LEVEL",
-                      help="Debug level for stdout output")
-    parser.add_option("--priority", type="string", help="GnuTLS"
-                      " priority string (see GnuTLS documentation)")
-    parser.add_option("--servicename", type="string",
-                      metavar="NAME", help="Zeroconf service name")
-    parser.add_option("--configdir", type="string",
-                      default="/etc/mandos", metavar="DIR",
-                      help="Directory to search for configuration"
-                      " files")
-    parser.add_option("--no-dbus", action="store_false",
-                      dest="use_dbus", help="Do not provide D-Bus"
-                      " system bus interface")
-    parser.add_option("--no-ipv6", action="store_false",
-                      dest="use_ipv6", help="Do not use IPv6")
+    parser.add_option("-i", u"--interface", type=u"string",
+                      metavar="IF", help=u"Bind to interface IF")
+    parser.add_option("-a", u"--address", type=u"string",
+                      help=u"Address to listen for requests on")
+    parser.add_option("-p", u"--port", type=u"int",
+                      help=u"Port number to receive requests on")
+    parser.add_option("--check", action=u"store_true",
+                      help=u"Run self-test")
+    parser.add_option("--debug", action=u"store_true",
+                      help=u"Debug mode; run in foreground and log to"
+                      u" terminal")
+    parser.add_option("--debuglevel", type=u"string", metavar="LEVEL",
+                      help=u"Debug level for stdout output")
+    parser.add_option("--priority", type=u"string", help=u"GnuTLS"
+                      u" priority string (see GnuTLS documentation)")
+    parser.add_option("--servicename", type=u"string",
+                      metavar=u"NAME", help=u"Zeroconf service name")
+    parser.add_option("--configdir", type=u"string",
+                      default=u"/etc/mandos", metavar=u"DIR",
+                      help=u"Directory to search for configuration"
+                      u" files")
+    parser.add_option("--no-dbus", action=u"store_false",
+                      dest=u"use_dbus", help=u"Do not provide D-Bus"
+                      u" system bus interface")
+    parser.add_option("--no-ipv6", action=u"store_false",
+                      dest=u"use_ipv6", help=u"Do not use IPv6")
     options = parser.parse_args()[0]
     
     if options.check:
@@ -1707,39 +1707,39 @@
         sys.exit()
     
     # Default values for config file for server-global settings
-    server_defaults = { "interface": "",
-                        "address": "",
-                        "port": "",
-                        "debug": "False",
-                        "priority":
-                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
-                        "servicename": "Mandos",
-                        "use_dbus": "True",
-                        "use_ipv6": "True",
-                        "debuglevel": "",
+    server_defaults = { u"interface": u"",
+                        u"address": u"",
+                        u"port": u"",
+                        u"debug": u"False",
+                        u"priority":
+                        u"SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
+                        u"servicename": u"Mandos",
+                        u"use_dbus": u"True",
+                        u"use_ipv6": u"True",
+                        u"debuglevel": u"",
                         }
     
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
     del server_defaults
     server_config.read(os.path.join(options.configdir,
-                                    "mandos.conf"))
+                                    u"mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
-    for option in ("debug", "use_dbus", "use_ipv6"):
-        server_settings[option] = server_config.getboolean("DEFAULT",
+    for option in (u"debug", u"use_dbus", u"use_ipv6"):
+        server_settings[option] = server_config.getboolean(u"DEFAULT",
                                                            option)
     if server_settings["port"]:
-        server_settings["port"] = server_config.getint("DEFAULT",
-                                                       "port")
+        server_settings["port"] = server_config.getint(u"DEFAULT",
+                                                       u"port")
     del server_config
     
     # Override the settings from the config file with command line
     # options, if set.
-    for option in ("interface", "address", "port", "debug",
-                   "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel"):
+    for option in (u"interface", u"address", u"port", u"debug",
+                   u"priority", u"servicename", u"configdir",
+                   u"use_dbus", u"use_ipv6", u"debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -1753,59 +1753,59 @@
     ##################################################################
     
     # For convenience
-    debug = server_settings["debug"]
-    debuglevel = server_settings["debuglevel"]
-    use_dbus = server_settings["use_dbus"]
-    use_ipv6 = server_settings["use_ipv6"]
+    debug = server_settings[u"debug"]
+    debuglevel = server_settings[u"debuglevel"]
+    use_dbus = server_settings[u"use_dbus"]
+    use_ipv6 = server_settings[u"use_ipv6"]
 
-    if server_settings["servicename"] != "Mandos":
+    if server_settings[u"servicename"] != u"Mandos":
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % server_settings["servicename"]))
+                               (u'Mandos (%s) [%%(process)d]:'
+                                u' %%(levelname)s: %%(message)s'
+                                % server_settings[u"servicename"]))
     
     # Parse config file with clients
-    client_defaults = { "timeout": "1h",
-                        "interval": "5m",
-                        "checker": "fping -q -- %%(host)s",
-                        "host": "",
-                        "approval_delay": "0s",
-                        "approval_duration": "1s",
+    client_defaults = { u"timeout": u"1h",
+                        u"interval": u"5m",
+                        u"checker": u"fping -q -- %%(host)s",
+                        u"host": u"",
+                        u"approval_delay": u"0s",
+                        u"approval_duration": u"1s",
                         }
     client_config = configparser.SafeConfigParser(client_defaults)
-    client_config.read(os.path.join(server_settings["configdir"],
-                                    "clients.conf"))
+    client_config.read(os.path.join(server_settings[u"configdir"],
+                                    u"clients.conf"))
     
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    tcp_server = MandosServer((server_settings["address"],
-                               server_settings["port"]),
+    tcp_server = MandosServer((server_settings[u"address"],
+                               server_settings[u"port"]),
                               ClientHandler,
-                              interface=(server_settings["interface"]
+                              interface=(server_settings[u"interface"]
                                          or None),
                               use_ipv6=use_ipv6,
                               gnutls_priority=
-                              server_settings["priority"],
+                              server_settings[u"priority"],
                               use_dbus=use_dbus)
     if not debug:
-        pidfilename = "/var/run/mandos.pid"
+        pidfilename = u"/var/run/mandos.pid"
         try:
-            pidfile = open(pidfilename, "w")
+            pidfile = open(pidfilename, u"w")
         except IOError:
-            logger.error("Could not open file %r", pidfilename)
+            logger.error(u"Could not open file %r", pidfilename)
     
     try:
-        uid = pwd.getpwnam("_mandos").pw_uid
-        gid = pwd.getpwnam("_mandos").pw_gid
+        uid = pwd.getpwnam(u"_mandos").pw_uid
+        gid = pwd.getpwnam(u"_mandos").pw_gid
     except KeyError:
         try:
-            uid = pwd.getpwnam("mandos").pw_uid
-            gid = pwd.getpwnam("mandos").pw_gid
+            uid = pwd.getpwnam(u"mandos").pw_uid
+            gid = pwd.getpwnam(u"mandos").pw_gid
         except KeyError:
             try:
-                uid = pwd.getpwnam("nobody").pw_uid
-                gid = pwd.getpwnam("nobody").pw_gid
+                uid = pwd.getpwnam(u"nobody").pw_uid
+                gid = pwd.getpwnam(u"nobody").pw_gid
             except KeyError:
                 uid = 65534
                 gid = 65534
@@ -1833,7 +1833,7 @@
         
         @gnutls.library.types.gnutls_log_func
         def debug_gnutls(level, string):
-            logger.debug("GnuTLS: %s", string[:-1])
+            logger.debug(u"GnuTLS: %s", string[:-1])
         
         (gnutls.library.functions
          .gnutls_global_set_log_function(debug_gnutls))
@@ -1860,20 +1860,20 @@
     # End of Avahi example code
     if use_dbus:
         try:
-            bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
+            bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos",
                                             bus, do_not_queue=True)
         except dbus.exceptions.NameExistsException, e:
-            logger.error(unicode(e) + ", disabling D-Bus")
+            logger.error(unicode(e) + u", disabling D-Bus")
             use_dbus = False
-            server_settings["use_dbus"] = False
+            server_settings[u"use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiService(name = server_settings["servicename"],
-                           servicetype = "_mandos._tcp",
+    service = AvahiService(name = server_settings[u"servicename"],
+                           servicetype = u"_mandos._tcp",
                            protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
-                             (str(server_settings["interface"])))
+                             (str(server_settings[u"interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -1899,16 +1899,16 @@
                         client_config, section)))
             for section in client_config.sections()))
     if not tcp_server.clients:
-        logger.warning("No clients defined")
+        logger.warning(u"No clients defined")
         
     if not debug:
         try:
             with pidfile:
                 pid = os.getpid()
-                pidfile.write(str(pid) + "\n".encode("utf-8"))
+                pidfile.write(str(pid) + "\n")
             del pidfile
         except IOError:
-            logger.error("Could not write to file %r with PID %d",
+            logger.error(u"Could not write to file %r with PID %d",
                          pidfilename, pid)
         except NameError:
             # "pidfile" was never created
@@ -1924,40 +1924,40 @@
         class MandosDBusService(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
-                dbus.service.Object.__init__(self, bus, "/")
-            _interface = "se.bsnet.fukt.Mandos"
+                dbus.service.Object.__init__(self, bus, u"/")
+            _interface = u"se.bsnet.fukt.Mandos"
             
-            @dbus.service.signal(_interface, signature="o")
+            @dbus.service.signal(_interface, signature=u"o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.signal(_interface, signature="ss")
+            @dbus.service.signal(_interface, signature=u"ss")
             def ClientNotFound(self, fingerprint, address):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.signal(_interface, signature="os")
+            @dbus.service.signal(_interface, signature=u"os")
             def ClientRemoved(self, objpath, name):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.method(_interface, out_signature="ao")
+            @dbus.service.method(_interface, out_signature=u"ao")
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
                                   for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
-                                 out_signature="a{oa{sv}}")
+                                 out_signature=u"a{oa{sv}}")
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAll(""))
+                    ((c.dbus_object_path, c.GetAll(u""))
                      for c in tcp_server.clients),
-                    signature="oa{sv}")
+                    signature=u"oa{sv}")
             
-            @dbus.service.method(_interface, in_signature="o")
+            @dbus.service.method(_interface, in_signature=u"o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
                 for c in tcp_server.clients:
@@ -2005,11 +2005,11 @@
     # Find out what port we got
     service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
-        logger.info("Now listening on address %r, port %d,"
+        logger.info(u"Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d"
                     % tcp_server.socket.getsockname())
     else:                       # IPv4
-        logger.info("Now listening on address %r, port %d"
+        logger.info(u"Now listening on address %r, port %d"
                     % tcp_server.socket.getsockname())
     
     #service.interface = tcp_server.socket.getsockname()[3]
@@ -2019,7 +2019,7 @@
         try:
             service.activate()
         except dbus.exceptions.DBusException, error:
-            logger.critical("DBusException: %s", error)
+            logger.critical(u"DBusException: %s", error)
             cleanup()
             sys.exit(1)
         # End of Avahi example code
@@ -2029,17 +2029,17 @@
                              (tcp_server.handle_request
                               (*args[2:], **kwargs) or True))
         
-        logger.debug("Starting main loop")
+        logger.debug(u"Starting main loop")
         main_loop.run()
     except AvahiError, error:
-        logger.critical("AvahiError: %s", error)
+        logger.critical(u"AvahiError: %s", error)
         cleanup()
         sys.exit(1)
     except KeyboardInterrupt:
         if debug:
             print >> sys.stderr
-        logger.debug("Server received KeyboardInterrupt")
-    logger.debug("Server exiting")
+        logger.debug(u"Server received KeyboardInterrupt")
+    logger.debug(u"Server exiting")
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-02-11 19:02:24 +0000
+++ mandos-monitor	2010-10-11 17:45:21 +0000
@@ -22,7 +22,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, absolute_import, print_function, unicode_literals
+from __future__ import division, absolute_import, with_statement
 
 import sys
 import os
@@ -42,7 +42,7 @@
 
 import locale
 
-locale.setlocale(locale.LC_ALL, '')
+locale.setlocale(locale.LC_ALL, u'')
 
 import logging
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
@@ -65,9 +65,9 @@
     "Parse an ISO 8601 date string to a datetime.datetime()"
     if not iso:
         return None
-    d, t = iso.split("T", 1)
-    year, month, day = d.split("-", 2)
-    hour, minute, second = t.split(":", 2)
+    d, t = iso.split(u"T", 1)
+    year, month, day = d.split(u"-", 2)
+    hour, minute, second = t.split(u":", 2)
     second, fraction = divmod(float(second), 1)
     return datetime.datetime(int(year),
                              int(month),
@@ -86,7 +86,7 @@
         self.proxy = proxy_object # Mandos Client proxy object
         
         self.properties = dict()
-        self.proxy.connect_to_signal("PropertyChanged",
+        self.proxy.connect_to_signal(u"PropertyChanged",
                                      self.property_changed,
                                      client_interface,
                                      byte_arrays=True)
@@ -127,9 +127,9 @@
         self.last_checker_failed = False
         
         # The widget shown normally
-        self._text_widget = urwid.Text("")
+        self._text_widget = urwid.Text(u"")
         # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text("")
+        self._focus_text_widget = urwid.Text(u"")
         super(MandosClientWidget, self).__init__(
             update_hook=update_hook, delete_hook=delete_hook,
             *args, **kwargs)
@@ -137,7 +137,7 @@
         self.opened = False
         
         last_checked_ok = isoformat_to_datetime(self.properties
-                                                ["LastCheckedOK"])
+                                                [u"LastCheckedOK"])
         if last_checked_ok is None:
             self.last_checker_failed = True
         else:
@@ -146,7 +146,7 @@
                                         > datetime.timedelta
                                         (milliseconds=
                                          self.properties
-                                         ["Interval"]))
+                                         [u"Interval"]))
         
         if self.last_checker_failed:
             self.using_timer(True)
@@ -154,23 +154,23 @@
         if self.need_approval:
             self.using_timer(True)
         
-        self.proxy.connect_to_signal("CheckerCompleted",
+        self.proxy.connect_to_signal(u"CheckerCompleted",
                                      self.checker_completed,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal("CheckerStarted",
+        self.proxy.connect_to_signal(u"CheckerStarted",
                                      self.checker_started,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal("GotSecret",
+        self.proxy.connect_to_signal(u"GotSecret",
                                      self.got_secret,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal("NeedApproval",
+        self.proxy.connect_to_signal(u"NeedApproval",
                                      self.need_approval,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal("Rejected",
+        self.proxy.connect_to_signal(u"Rejected",
                                      self.rejected,
                                      client_interface,
                                      byte_arrays=True)
@@ -178,7 +178,7 @@
     def property_changed(self, property=None, value=None):
         super(self, MandosClientWidget).property_changed(property,
                                                          value)
-        if property == "ApprovalPending":
+        if property == u"ApprovalPending":
             using_timer(bool(value))
         
     def using_timer(self, flag):
@@ -203,9 +203,9 @@
             if self.last_checker_failed:
                 self.last_checker_failed = False
                 self.using_timer(False)
-            #self.logger('Checker for client %s (command "%s")'
-            #            ' was successful'
-            #            % (self.properties["Name"], command))
+            #self.logger(u'Checker for client %s (command "%s")'
+            #            u' was successful'
+            #            % (self.properties[u"Name"], command))
             self.update()
             return
         # Checker failed
@@ -213,57 +213,57 @@
             self.last_checker_failed = True
             self.using_timer(True)
         if os.WIFEXITED(condition):
-            self.logger('Checker for client %s (command "%s")'
-                        ' failed with exit code %s'
-                        % (self.properties["Name"], command,
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' failed with exit code %s'
+                        % (self.properties[u"Name"], command,
                            os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client %s (command "%s")'
-                        ' was killed by signal %s'
-                        % (self.properties["Name"], command,
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' was killed by signal %s'
+                        % (self.properties[u"Name"], command,
                            os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger('Checker for client %s (command "%s")'
-                        ' dumped core'
-                        % (self.properties["Name"], command))
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' dumped core'
+                        % (self.properties[u"Name"], command))
         else:
-            self.logger('Checker for client %s completed'
-                        ' mysteriously')
+            self.logger(u'Checker for client %s completed'
+                        u' mysteriously')
         self.update()
     
     def checker_started(self, command):
-        #self.logger('Client %s started checker "%s"'
-        #            % (self.properties["Name"], unicode(command)))
+        #self.logger(u'Client %s started checker "%s"'
+        #            % (self.properties[u"Name"], unicode(command)))
         pass
     
     def got_secret(self):
         self.last_checker_failed = False
-        self.logger('Client %s received its secret'
-                    % self.properties["Name"])
+        self.logger(u'Client %s received its secret'
+                    % self.properties[u"Name"])
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client %s needs approval within %s seconds'
+            message = u'Client %s needs approval within %s seconds'
         else:
-            message = 'Client %s will get its secret in %s seconds'
+            message = u'Client %s will get its secret in %s seconds'
         self.logger(message
-                    % (self.properties["Name"], timeout/1000))
+                    % (self.properties[u"Name"], timeout/1000))
         self.using_timer(True)
     
     def rejected(self, reason):
-        self.logger('Client %s was rejected; reason: %s'
-                    % (self.properties["Name"], reason))
+        self.logger(u'Client %s was rejected; reason: %s'
+                    % (self.properties[u"Name"], reason))
     
     def selectable(self):
         """Make this a "selectable" widget.
         This overrides the method from urwid.FlowWidget."""
         return True
     
-    def rows(self, maxcolrow, focus=False):
+    def rows(self, (maxcol,), focus=False):
         """How many rows this widget will occupy might depend on
         whether we have focus or not.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).rows(maxcolrow, focus=focus)
+        return self.current_widget(focus).rows((maxcol,), focus=focus)
     
     def current_widget(self, focus=False):
         if focus or self.opened:
@@ -273,56 +273,56 @@
     def update(self):
         "Called when what is visible on the screen should be updated."
         # How to add standout mode to a style
-        with_standout = { "normal": "standout",
-                          "bold": "bold-standout",
-                          "underline-blink":
-                              "underline-blink-standout",
-                          "bold-underline-blink":
-                              "bold-underline-blink-standout",
+        with_standout = { u"normal": u"standout",
+                          u"bold": u"bold-standout",
+                          u"underline-blink":
+                              u"underline-blink-standout",
+                          u"bold-underline-blink":
+                              u"bold-underline-blink-standout",
                           }
 
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = ('%(name)s: '
-                      % {"name": self.properties["Name"]})
-        if not self.properties["Enabled"]:
-            message = "DISABLED"
-        elif self.properties["ApprovalPending"]:
+        base = (u'%(name)s: '
+                      % {u"name": self.properties[u"Name"]})
+        if not self.properties[u"Enabled"]:
+            message = u"DISABLED"
+        elif self.properties[u"ApprovalPending"]:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
-                                         ["ApprovalDelay"])
+                                         [u"ApprovalDelay"])
             last_approval_request = isoformat_to_datetime(
-                self.properties["LastApprovalRequest"])
+                self.properties[u"LastApprovalRequest"])
             if last_approval_request is not None:
                 timer = timeout - (datetime.datetime.utcnow()
                                    - last_approval_request)
             else:
                 timer = datetime.timedelta()
-            if self.properties["ApprovedByDefault"]:
-                message = "Approval in %s. (d)eny?"
+            if self.properties[u"ApprovedByDefault"]:
+                message = u"Approval in %s. (d)eny?"
             else:
-                message = "Denial in %s. (a)pprove?"
+                message = u"Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
         elif self.last_checker_failed:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
-                                         ["Timeout"])
+                                         [u"Timeout"])
             last_ok = isoformat_to_datetime(
-                max((self.properties["LastCheckedOK"]
-                     or self.properties["Created"]),
-                    self.properties["LastEnabled"]))
+                max((self.properties[u"LastCheckedOK"]
+                     or self.properties[u"Created"]),
+                    self.properties[u"LastEnabled"]))
             timer = timeout - (datetime.datetime.utcnow() - last_ok)
-            message = ('A checker has failed! Time until client'
-                       ' gets disabled: %s'
+            message = (u'A checker has failed! Time until client'
+                       u' gets disabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
         else:
-            message = "enabled"
+            message = u"enabled"
         self._text = "%s%s" % (base, message)
             
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
-        textlist = [("normal", self._text)]
+        textlist = [(u"normal", self._text)]
         self._text_widget.set_text(textlist)
         self._focus_text_widget.set_text([(with_standout[text[0]],
                                            text[1])
@@ -348,40 +348,40 @@
         if self.delete_hook is not None:
             self.delete_hook(self)
     
-    def render(self, maxcolrow, focus=False):
+    def render(self, (maxcol,), focus=False):
         """Render differently if we have focus.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).render(maxcolrow,
+        return self.current_widget(focus).render((maxcol,),
                                                  focus=focus)
     
-    def keypress(self, maxcolrow, key):
+    def keypress(self, (maxcol,), key):
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
-        if key == "+":
+        if key == u"+":
             self.proxy.Enable(dbus_interface = client_interface)
-        elif key == "-":
+        elif key == u"-":
             self.proxy.Disable(dbus_interface = client_interface)
-        elif key == "a":
+        elif key == u"a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
                                dbus_interface = client_interface)
-        elif key == "d":
+        elif key == u"d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
                                   dbus_interface = client_interface)
-        elif key == "R" or key == "_" or key == "ctrl k":
+        elif key == u"R" or key == u"_" or key == u"ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
                                                   .object_path)
-        elif key == "s":
+        elif key == u"s":
             self.proxy.StartChecker(dbus_interface = client_interface)
-        elif key == "S":
+        elif key == u"S":
             self.proxy.StopChecker(dbus_interface = client_interface)
-        elif key == "C":
+        elif key == u"C":
             self.proxy.CheckedOK(dbus_interface = client_interface)
         # xxx
-#         elif key == "p" or key == "=":
+#         elif key == u"p" or key == "=":
 #             self.proxy.pause()
-#         elif key == "u" or key == ":":
+#         elif key == u"u" or key == ":":
 #             self.proxy.unpause()
-#         elif key == "RET":
+#         elif key == u"RET":
 #             self.open()
         else:
             return key
@@ -403,9 +403,10 @@
     "down" key presses, thus not allowing any containing widgets to
     use them as an excuse to shift focus away from this widget.
     """
-    def keypress(self, maxcolrow, key):
-        ret = super(ConstrainedListBox, self).keypress(maxcolrow, key)
-        if ret in ("up", "down"):
+    def keypress(self, (maxcol, maxrow), key):
+        ret = super(ConstrainedListBox, self).keypress((maxcol,
+                                                        maxrow), key)
+        if ret in (u"up", u"down"):
             return
         return ret
 
@@ -420,31 +421,31 @@
         self.screen = urwid.curses_display.Screen()
         
         self.screen.register_palette((
-                ("normal",
-                 "default", "default", None),
-                ("bold",
-                 "default", "default", "bold"),
-                ("underline-blink",
-                 "default", "default", "underline"),
-                ("standout",
-                 "default", "default", "standout"),
-                ("bold-underline-blink",
-                 "default", "default", ("bold", "underline")),
-                ("bold-standout",
-                 "default", "default", ("bold", "standout")),
-                ("underline-blink-standout",
-                 "default", "default", ("underline", "standout")),
-                ("bold-underline-blink-standout",
-                 "default", "default", ("bold", "underline",
-                                          "standout")),
+                (u"normal",
+                 u"default", u"default", None),
+                (u"bold",
+                 u"default", u"default", u"bold"),
+                (u"underline-blink",
+                 u"default", u"default", u"underline"),
+                (u"standout",
+                 u"default", u"default", u"standout"),
+                (u"bold-underline-blink",
+                 u"default", u"default", (u"bold", u"underline")),
+                (u"bold-standout",
+                 u"default", u"default", (u"bold", u"standout")),
+                (u"underline-blink-standout",
+                 u"default", u"default", (u"underline", u"standout")),
+                (u"bold-underline-blink-standout",
+                 u"default", u"default", (u"bold", u"underline",
+                                          u"standout")),
                 ))
         
         if urwid.supports_unicode():
-            self.divider = "─" # \u2500
-            #self.divider = "━" # \u2501
+            self.divider = u"─" # \u2500
+            #self.divider = u"━" # \u2501
         else:
-            #self.divider = "-" # \u002d
-            self.divider = "_" # \u005f
+            #self.divider = u"-" # \u002d
+            self.divider = u"_" # \u005f
         
         self.screen.start()
         
@@ -464,19 +465,19 @@
         # This keeps track of whether self.uilist currently has
         # self.logbox in it or not
         self.log_visible = True
-        self.log_wrap = "any"
+        self.log_wrap = u"any"
         
         self.rebuild()
-        self.log_message_raw(("bold",
-                              "Mandos Monitor version " + version))
-        self.log_message_raw(("bold",
-                              "q: Quit  ?: Help"))
+        self.log_message_raw((u"bold",
+                              u"Mandos Monitor version " + version))
+        self.log_message_raw((u"bold",
+                              u"q: Quit  ?: Help"))
         
         self.busname = domain + '.Mandos'
         self.main_loop = gobject.MainLoop()
         self.bus = dbus.SystemBus()
         mandos_dbus_objc = self.bus.get_object(
-            self.busname, "/", follow_name_owner_changes=True)
+            self.busname, u"/", follow_name_owner_changes=True)
         self.mandos_serv = dbus.Interface(mandos_dbus_objc,
                                           dbus_interface
                                           = server_interface)
@@ -487,17 +488,17 @@
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
-         .connect_to_signal("ClientRemoved",
+         .connect_to_signal(u"ClientRemoved",
                             self.find_and_remove_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal("ClientAdded",
+         .connect_to_signal(u"ClientAdded",
                             self.add_new_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal("ClientNotFound",
+         .connect_to_signal(u"ClientNotFound",
                             self.client_not_found,
                             dbus_interface=server_interface,
                             byte_arrays=True))
@@ -518,8 +519,8 @@
                             path=path)
     
     def client_not_found(self, fingerprint, address):
-        self.log_message(("Client with address %s and fingerprint %s"
-                          " could not be found" % (address,
+        self.log_message((u"Client with address %s and fingerprint %s"
+                          u" could not be found" % (address,
                                                     fingerprint)))
     
     def rebuild(self):
@@ -541,7 +542,7 @@
     
     def log_message(self, message):
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + ": " + message)
+        self.log_message_raw(timestamp + u": " + message)
     
     def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
@@ -550,26 +551,26 @@
             and len(self.log) > self.max_log_length):
             del self.log[0:len(self.log)-self.max_log_length-1]
         self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from="above")
+                              coming_from=u"above")
         self.refresh()
     
     def toggle_log_display(self):
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        #self.log_message("Log visibility changed to: "
+        #self.log_message(u"Log visibility changed to: "
         #                 + unicode(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
         Currently, this toggles wrapping of text lines."""
-        if self.log_wrap == "clip":
-            self.log_wrap = "any"
+        if self.log_wrap == u"clip":
+            self.log_wrap = u"any"
         else:
-            self.log_wrap = "clip"
+            self.log_wrap = u"clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        #self.log_message("Wrap mode: " + self.log_wrap)
+        #self.log_message(u"Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find an client from its object path and remove it.
@@ -602,7 +603,7 @@
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(None, lambda c: c.properties["Name"])
+        self.clients.sort(None, lambda c: c.properties[u"Name"])
         self.refresh()
     
     def remove_client(self, client, path=None):
@@ -639,15 +640,15 @@
     
     def process_input(self, source, condition):
         keys = self.screen.get_input()
-        translations = { "ctrl n": "down",      # Emacs
-                         "ctrl p": "up",        # Emacs
-                         "ctrl v": "page down", # Emacs
-                         "meta v": "page up",   # Emacs
-                         " ": "page down",      # less
-                         "f": "page down",      # less
-                         "b": "page up",        # less
-                         "j": "down",           # vi
-                         "k": "up",             # vi
+        translations = { u"ctrl n": u"down",      # Emacs
+                         u"ctrl p": u"up",        # Emacs
+                         u"ctrl v": u"page down", # Emacs
+                         u"meta v": u"page up",   # Emacs
+                         u" ": u"page down",      # less
+                         u"f": u"page down",      # less
+                         u"b": u"page up",        # less
+                         u"j": u"down",           # vi
+                         u"k": u"up",             # vi
                          }
         for key in keys:
             try:
@@ -655,66 +656,66 @@
             except KeyError:    # :-)
                 pass
             
-            if key == "q" or key == "Q":
+            if key == u"q" or key == u"Q":
                 self.stop()
                 break
-            elif key == "window resize":
+            elif key == u"window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "\f":  # Ctrl-L
+            elif key == u"\f":  # Ctrl-L
                 self.refresh()
-            elif key == "l" or key == "D":
+            elif key == u"l" or key == u"D":
                 self.toggle_log_display()
                 self.refresh()
-            elif key == "w" or key == "i":
+            elif key == u"w" or key == u"i":
                 self.change_log_display()
                 self.refresh()
-            elif key == "?" or key == "f1" or key == "esc":
+            elif key == u"?" or key == u"f1" or key == u"esc":
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw(("bold",
-                                      "  ".
-                                      join(("q: Quit",
-                                            "?: Help",
-                                            "l: Log window toggle",
-                                            "TAB: Switch window",
-                                            "w: Wrap (log)"))))
-                self.log_message_raw(("bold",
-                                      "  "
-                                      .join(("Clients:",
-                                             "+: Enable",
-                                             "-: Disable",
-                                             "R: Remove",
-                                             "s: Start new checker",
-                                             "S: Stop checker",
-                                             "C: Checker OK",
-                                             "a: Approve",
-                                             "d: Deny"))))
+                self.log_message_raw((u"bold",
+                                      u"  ".
+                                      join((u"q: Quit",
+                                            u"?: Help",
+                                            u"l: Log window toggle",
+                                            u"TAB: Switch window",
+                                            u"w: Wrap (log)"))))
+                self.log_message_raw((u"bold",
+                                      u"  "
+                                      .join((u"Clients:",
+                                             u"+: Enable",
+                                             u"-: Disable",
+                                             u"R: Remove",
+                                             u"s: Start new checker",
+                                             u"S: Stop checker",
+                                             u"C: Checker OK",
+                                             u"a: Approve",
+                                             u"d: Deny"))))
                 self.refresh()
-            elif key == "tab":
+            elif key == u"tab":
                 if self.topwidget.get_focus() is self.logbox:
                     self.topwidget.set_focus(0)
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            #elif (key == "end" or key == "meta >" or key == "G"
-            #      or key == ">"):
+            #elif (key == u"end" or key == u"meta >" or key == u"G"
+            #      or key == u">"):
             #    pass            # xxx end-of-buffer
-            #elif (key == "home" or key == "meta <" or key == "g"
-            #      or key == "<"):
+            #elif (key == u"home" or key == u"meta <" or key == u"g"
+            #      or key == u"<"):
             #    pass            # xxx beginning-of-buffer
-            #elif key == "ctrl e" or key == "$":
+            #elif key == u"ctrl e" or key == u"$":
             #    pass            # xxx move-end-of-line
-            #elif key == "ctrl a" or key == "^":
+            #elif key == u"ctrl a" or key == u"^":
             #    pass            # xxx move-beginning-of-line
-            #elif key == "ctrl b" or key == "meta (" or key == "h":
+            #elif key == u"ctrl b" or key == u"meta (" or key == u"h":
             #    pass            # xxx left
-            #elif key == "ctrl f" or key == "meta )" or key == "l":
+            #elif key == u"ctrl f" or key == u"meta )" or key == u"l":
             #    pass            # xxx right
-            #elif key == "a":
+            #elif key == u"a":
             #    pass            # scroll up log
-            #elif key == "z":
+            #elif key == u"z":
             #    pass            # scroll down log
             elif self.topwidget.selectable():
                 self.topwidget.keypress(self.size, key)

